.nolist
include \masm32\include\masm32rt.inc

.686
.xmm

include \masm32\macros\timers.asm	
; get them from the 
;[url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

FormatNum PROTO  :DWORD

LOOP_COUNT	= 1000	; 1000000 would be a typical value
                        ; reduced to 1,000 because the string to fill is big.
.data
Sep         DB  ",",0   ;   used for readability of big numbers
lpSep       DD  Sep     ;   When calling GetNumberFormat
Tsep        DD  ".",0   ;   
lpTsep      DD  Tsep    ; 

;           Number      DB  "                    ",0
lpNumber    DD  0       ; Pointer to string to format 


.data?


DataPtr     dd ?               ; same thing as above 

Buffer      DB  255 dup(?)     ; used by GetNumberFormat
NumFmt      NUMBERFMT <>       ; to format with thousand separator integer numbers

;---------------------------------------------------------------------------------
; Structure for number formatting
;---------------------------------------------------------------------------------   
; NUMBERFMTA STRUCT
;    NumDigits         DWORD      ?
;    LeadingZero       DWORD      ?
;    Grouping          DWORD      ?
;    lpDecimalSep      DWORD      ?
;    lpThousandSep     DWORD      ?
;    NegativeOrder     DWORD      ?
; NUMBERFMTA ENDS
;
; NUMBERFMT  equ  <NUMBERFMTA>     
;---------------------------------------------------------------------------------
 

.code
start:
	push 1
	call ShowCpu				; print brand string and SSE level

;---------------------------------------------------------------------------------
; Initialize structure for calling GetNumberFormat
;---------------------------------------------------------------------------------

      mov NumFmt.NumDigits, 0               ; 0 for No decimal digits
      mov NumFmt.LeadingZero, 0             ; 0 = No leading zeroes
      mov NumFmt.Grouping, 3                ; Groups of three numbers
      mov NumFmt.lpDecimalSep,  offset Sep  ; Pointer to NULL terminated string with the decimal separator 
      mov NumFmt.lpThousandSep, offset Tsep ; Pointer to NULL terminated string with the thousand separator
      mov NumFmt.NegativeOrder, 0           ; Negative number mode

      align 16

      invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,16*1024*1024 ; Alex's suggestion for reducing
                                                                  ; time of compiling with ML.EXE  

      mov DataPtr, eax                     ; Alex's suggestion, the address of allocated area in eax 
      
	REPEAT 2

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			invoke RtlZeroMemory, DataPtr, 16000000 ; instead of "offset Dest" use the Pointer
                                                          ; to allocated area as Alex suggested  
		counter_end
;----------------------------------------------------------------------------------------------------
; Instructions to format an integer number, converted to string, with thousand separators
; Better if it stays in a PROC to call before diaplaying the Number of Cycles elapsed
;----------------------------------------------------------------------------------------------------


            mov lpNumber, sstr$(eax)
            

;            INVOKE FormatNum, lpNumber  

            INVOKE GetNumberFormat, NULL, 0, lpNumber, offset NumFmt, offset Buffer, 255 
                            
		print offset Buffer, 9, "cycles for RtlZeroMemory", 13, 10

;----------------------------------------------------------------------------------------------------

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		    mov eax, DataPtr
		    mov ecx, 2000000
		    mov ebx,20202020h ; change filling ebx to one command
		@@:
		    mov [eax], ebx
		    mov [eax+4], ebx
		    add eax, 8
		    dec ecx
		    jnz @B
		counter_end

            mov lpNumber, sstr$(eax)

;            INVOKE FormatNum, lpNumber  

            INVOKE GetNumberFormat, NULL, 0, lpNumber, offset NumFmt, offset Buffer, 255 
            
		print offset Buffer, 9, "cycles for FrkTons", 13, 10

;----------------------------------------------------------------------------------------------------

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			push edi
			mov ecx, 4000000
			mov edi, DataPtr
			mov eax, 20202020h
			rep stosd
			pop edi
		counter_end

            mov lpNumber, sstr$(eax)

;            INVOKE FormatNum, lpNumber  

            INVOKE GetNumberFormat, NULL, 0, lpNumber, offset NumFmt, offset Buffer, 255 

		print offset Buffer, 9, "cycles for rep stosd", 13, 10

;----------------------------------------------------------------------------------------------------

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			mov edx, DataPtr
			lea ecx, [edx+16000000]
			mov eax, 20202020h
			movd xmm0, eax
			pshufd xmm0, xmm0, 0
		@@:
			movdqa [edx], xmm0
			add edx, 16
			cmp edx, ecx
			jl @B
		counter_end

            mov lpNumber, sstr$(eax)

;            INVOKE FormatNum, lpNumber  

            INVOKE GetNumberFormat, NULL, 0, lpNumber, offset NumFmt, offset Buffer, 255 

		print offset Buffer, 9, "cycles for movdqa", 13, 10

;----------------------------------------------------------------------------------------------------

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			mov edx, DataPtr
			lea ecx, [edx+16000000]
			mov eax, 20202020h
			movd xmm0, eax
			pshufd xmm0, xmm0, 0
		@@:
			movaps [edx], xmm0
			add edx, 16
			cmp edx, ecx
			jl @B
		counter_end

            mov lpNumber, sstr$(eax)

;            INVOKE FormatNum, lpNumber  

            INVOKE GetNumberFormat, NULL, 0, lpNumber, offset NumFmt, offset Buffer, 255 

		print offset Buffer, 9, "cycles for movaps", 13, 10

;----------------------------------------------------------------------------------------------------

		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			mov edx, DataPtr
			lea ecx, [edx+16000000]
			mov eax, 20202020h
			movd xmm0, eax
			pshufd xmm0, xmm0, 0
                  movdqa xmm1, xmm0 
                  movdqa xmm2, xmm0 
                  movdqa xmm3, xmm0 
                  movdqa xmm4, xmm0                                      

		@@:
			movdqa [edx], xmm0
			movdqa [edx + 16], xmm1
			movdqa [edx + 32], xmm2
			movdqa [edx + 48], xmm3
			movdqa [edx + 64], xmm4
			add edx, 80
			cmp edx, ecx
			jl @B
		counter_end

            mov lpNumber, sstr$(eax)

;            INVOKE FormatNum, lpNumber  

            INVOKE GetNumberFormat, NULL, 0, lpNumber, offset NumFmt, offset Buffer, 255 
            
		print offset Buffer, 9, "cycles for FrkTons New", 13, 10

;----------------------------------------------------------------------------------------------------

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			mov edx, DataPtr
			lea ecx, [edx+16000000]
			mov eax, 20202020h
			movd xmm0, eax
			pshufd xmm0, xmm0, 0
		@@:
			movups [edx], xmm0
			add edx, 16
			cmp edx, ecx
			jl @B
		counter_end

            mov lpNumber, sstr$(eax)

;            INVOKE FormatNum, lpNumber  

            INVOKE GetNumberFormat, NULL, 0, lpNumber, offset NumFmt, offset Buffer, 255 
            
		print offset Buffer, 9, "cycles for movups", 13, 10

;----------------------------------------------------------------------------------------------------

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			mov edx, DataPtr
			lea ecx, [edx+16000000]
			mov eax, 20202020h
			movd xmm0, eax
			pshufd xmm0, xmm0, 0
		@@:
			movupd [edx], xmm0
			add edx, 16
			cmp edx, ecx
			jl @B
		counter_end

            mov lpNumber, sstr$(eax)

;            INVOKE FormatNum, lpNumber  

            INVOKE GetNumberFormat, NULL, 0, lpNumber, offset NumFmt, offset Buffer, 255 
            
            print offset Buffer, 9, "cycles for movupd", 13, 10

;----------------------------------------------------------------------------------------------------

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			mov edx, DataPtr
			lea ecx, [edx+16000000]
			mov eax, 20202020h
			movd xmm0, eax
			pshufd xmm0, xmm0, 0
		@@:
			MOVNTDQ [edx], xmm0
			add edx, 16
			cmp edx, ecx
			jl @B
		counter_end

            mov lpNumber, sstr$(eax)

;            INVOKE FormatNum, lpNumber  

            INVOKE GetNumberFormat, NULL, 0, lpNumber, offset NumFmt, offset Buffer, 255 

		print offset Buffer, 9, "cycles for MOVNTDQ", 13, 10, 10

;----------------------------------------------------------------------------------------------------

	ENDM

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

;----------------------------------------------------------------------------------------------------
; Procedure for formatting a string with thousand comma/point separator
;----------------------------------------------------------------------------------------------------


FormatNum PROC PtrNumber:DWORD

  invoke GetNumberFormat, NULL, 0, PtrNumber, offset NumFmt, offset Buffer, 255

FormatNum ENDP

;----------------------------------------------------------------------------------------------------

ShowCpu proc	; mode:DWORD

COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]